/*****************************************************************
 * Copyright (c) ParaSoft Corporation 1991.  All rights reserved.*
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft       *
 * The copyright notice above does not evidence any              *
 * actual or intended publication of such source code.           *
 *****************************************************************/

#include "extern.h"

/***************************** C H E C K *********************************/

Node *check_BackspaceStmt (root)
Node *root;
{
	return check_FilposStmt (root);
}

Node *check_EndFileStmt (root)
Node *root;
{
	return check_FilposStmt (root);
}

Node *check_RewindStmt (root)
Node *root;
{
	return check_FilposStmt (root);
}

Node *check_FilposStmt (root)
Node *root;
{
	struct S_BackspaceStmt *stmt = &root->BackspaceStmt;
	Unit *unit = unit_malloc ();
	Node *list, *nspec, *temp;
	int first;
	struct S_IoSpec *spec;
	char *name;

	if (flag_cubix)
		cubix_io_called = 1;

	stmt->unit = unit;

	if (stmt->Rp != NN) {
		stmt->Lpeqi = &Lp;

		list = list_invert (stmt->IoSpecList);

		first = 1;
		for (LIST_LOOP (nspec, list, temp)) {
			spec = &nspec->IoSpec;

			if (spec->Name == NN) {
				if (first) {	
					if (unit->unit != NN) {
						io_err_spec_used ("UNIT");
						continue;
					}

					if (!IS_INTEGER (spec->Expr)) {
						io_err_spec_type ("UNIT", "INTEGER");
						continue;
					}

					unit->unit = spec->Expr;
				}
				else
					fatal (
					"UNIT specifier with keyword omitted must be the first item in OPEN");
			}
			else {
				name = U_strupper (spec->Name->com.str);

				if (spec->Times != NN) {
					sprintf (serr, "cannot use '*' with specifier %s", name);
					fatal (serr);
					continue;
				}

				if (io_spec_is ("IOSTAT", name, "INTEGER", spec, unit->iostat)) {
					if (spec->Expr->com.type != NAME) {
						fatal ("specifier IOSTAT needs a variable");
						continue;
					}

					unit->iostat = spec->Expr;
				}
				else if (io_spec_is ("ERR", name, "INTEGER", spec, unit->err)) {
					if (spec->Expr->com.type != INTEGER_CONSTANT) {
						fatal ("specifier ERR needs a label");
						continue;
					}

					unit->err = spec->Expr;

					label_install_ref (spec->Expr);
				}
			}

			if (first)
				first = 0;
		}
	}
	else {
		switch (stmt->Expr->com.type) {

		case PRIMARY:
			unit->unit = stmt->Expr->Primary.Expr;
			break;

		default:
			unit->unit = stmt->Expr;
			break;

		}
	}

	return root;
}

/***************************** W R I T E *********************************/

write_BackspaceStmt (node)
Node *node;
{
	if (flag_cubix)
		cubix_write_FilposStmt (node);
	else
		ochl (node);
}

write_EndFileStmt (node)
Node *node;
{
	if (flag_cubix)
		cubix_write_FilposStmt (node);
	else
		ochl (node);
}

write_RewindStmt (node)
Node *node;
{
	if (flag_cubix)
		cubix_write_FilposStmt (node);
	else
		ochl (node);
}

write_StopStmt (node)
Node *node;
{
	if (flag_cubix)
		cubix_write_StopStmt (node);
	else
		ochl (node);
}
